Coin: SoRotateCylindricalDragger Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

SoRotateCylindricalDragger Class Reference
Dragger Classes

The SoRotateCylindricalDragger class is for rotating geometry around a single axis. More...

`#include <Inventor/draggers/SoRotateCylindricalDragger.h>`

Inheritance diagram for SoRotateCylindricalDragger:

## Public Member Functions
virtual SoType | getTypeId (void) const
virtual const SoNodekitCatalog * | getNodekitCatalog (void) const
| SoRotateCylindricalDragger (void)
void | setProjector (SbCylinderProjector *p)
const SbCylinderProjector * | getProjector (void) const
Public Member Functions inherited from SoDragger
virtual void | callback (SoCallbackAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
void | setProjectorEpsilon (const float epsilon)
float | getProjectorEpsilon (void) const
void | addStartCallback (SoDraggerCB *func, void *data=NULL)
void | removeStartCallback (SoDraggerCB *func, void *data=NULL)
void | addMotionCallback (SoDraggerCB *func, void *data=NULL)
void | removeMotionCallback (SoDraggerCB *func, void *data=NULL)
void | addFinishCallback (SoDraggerCB *func, void *data=NULL)
void | removeFinishCallback (SoDraggerCB *func, void *data=NULL)
void | addValueChangedCallback (SoDraggerCB *func, void *data=NULL)
void | removeValueChangedCallback (SoDraggerCB *func, void *data=NULL)
void | setMinGesture (int pixels)
int | getMinGesture (void) const
SbBool | enableValueChangedCallbacks (SbBool newval)
const SbMatrix & | getMotionMatrix (void)
void | addOtherEventCallback (SoDraggerCB *func, void *data=NULL)
void | removeOtherEventCallback (SoDraggerCB *func, void *data=NULL)
void | registerChildDragger (SoDragger *child)
void | unregisterChildDragger (SoDragger *child)
void | registerChildDraggerMovingIndependently (SoDragger *child)
void | unregisterChildDraggerMovingIndependently (SoDragger *child)
SbMatrix | getLocalToWorldMatrix (void)
SbMatrix | getWorldToLocalMatrix (void)
SbVec3f | getLocalStartingPoint (void)
SbVec3f | getWorldStartingPoint (void)
void | getPartToLocalMatrix (const SbName &partname, SbMatrix &parttolocalmatrix, SbMatrix &localtopartmatrix)
void | transformMatrixLocalToWorld (const SbMatrix &frommatrix, SbMatrix &tomatrix)
void | transformMatrixWorldToLocal (const SbMatrix &frommatrix, SbMatrix &tomatrix)
void | transformMatrixToLocalSpace (const SbMatrix &frommatrix, SbMatrix &tomatrix, const SbName &fromspacepartname)
virtual void | setMotionMatrix (const SbMatrix &newmatrix)
void | valueChanged (void)
const SbMatrix & | getStartMotionMatrix (void)
virtual void | saveStartParameters (void)
const SoPath * | getPickPath (void) const
const SoEvent * | getEvent (void) const
SoPath * | createPathToThis (void)
const SoPath * | getSurrogatePartPickedOwner (void) const
const SbName & | getSurrogatePartPickedName (void) const
const SoPath * | getSurrogatePartPickedPath (void) const
void | setStartingPoint (const SoPickedPoint *newpoint)
void | setStartingPoint (const SbVec3f &newpoint)
const SbViewVolume & | getViewVolume (void)
void | setViewVolume (const SbViewVolume &vol)
const SbViewportRegion & | getViewportRegion (void)
void | setViewportRegion (const SbViewportRegion &reg)
SoHandleEventAction * | getHandleEventAction (void) const
void | setHandleEventAction (SoHandleEventAction *newAction)
void | setTempPathToThis (const SoPath *somethingclose)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
void | workFieldsIntoTransform (SbMatrix &mtx)
void | setFrontOnProjector (ProjectorFrontSetting newval)
ProjectorFrontSetting | getFrontOnProjector (void) const
Public Member Functions inherited from SoInteractionKit
| SoInteractionKit (void)
virtual SbBool | setPartAsPath (const SbName &partname, SoPath *path)
virtual SbBool | setPartAsDefault (const SbName &partname, SoNode *node, SbBool onlyifdefault=TRUE)
virtual SbBool | setPartAsDefault (const SbName &partname, const SbName &nodename, SbBool onlyifdefault=TRUE)
SbBool | isPathSurrogateInMySubgraph (const SoPath *path, SoPath *&pathToOwner, SbName &surrogatename, SoPath *&surrogatepath, SbBool fillargs=TRUE)
SbBool | isPathSurrogateInMySubgraph (const SoPath *path)
virtual SbBool | setPart (const SbName &partname, SoNode *from)
Public Member Functions inherited from SoBaseKit
| SoBaseKit (void)
virtual SoNode * | getPart (const SbName &partname, SbBool makeifneeded)
SbString | getPartString (const SoBase *part)
virtual SoNodeKitPath * | createPathToPart (const SbName &partname, SbBool makeifneeded, const SoPath *pathtoextend=NULL)
SbBool | set (const char *namevaluepairliststring)
SbBool | set (const char *partnamestring, const char *parameterstring)
virtual void | doAction (SoAction *action)
virtual SoChildList * | getChildren (void) const
void | printDiagram (void)
void | printSubDiagram (const SbName &rootname, int level)
void | printTable (void)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | forceChildDrivenWriteRefs (SoOutput *out)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | pick (SoPickAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | startNotify (void)
virtual void | notify (SoNotList *l)
SbUniqueId | getNodeId (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions
static SoType | getClassTypeId (void)
static const SoNodekitCatalog * | getClassNodekitCatalog (void)
static void | initClass (void)
Static Public Member Functions inherited from SoDragger
static SoType | getClassTypeId (void)
static const SoNodekitCatalog * | getClassNodekitCatalog (void)
static void | setMinScale (float newminscale)
static float | getMinScale (void)
static void | workValuesIntoTransform (SbMatrix &mtx, const SbVec3f *translationptr, const SbRotation *rotationptr, const SbVec3f *scalefactorptr, const SbRotation *scaleorientationptr, const SbVec3f *centerptr)
static void | getTransformFast (SbMatrix &mtx, SbVec3f &translation, SbRotation &rotation, SbVec3f &scalefactor, SbRotation &scaleorientation, const SbVec3f &center)
static void | getTransformFast (SbMatrix &mtx, SbVec3f &translation, SbRotation &rotation, SbVec3f &scalefactor, SbRotation &scaleorientation)
static SbMatrix | appendTranslation (const SbMatrix &mtx, const SbVec3f &translation, const SbMatrix *conversion=NULL)
static SbMatrix | appendScale (const SbMatrix &mtx, const SbVec3f &scale, const SbVec3f &scalecenter, const SbMatrix *conversion=NULL)
static SbMatrix | appendRotation (const SbMatrix &mtx, const SbRotation &rot, const SbVec3f &rotcenter, const SbMatrix *conversion=NULL)
static void | initClass (void)
static void | initClasses (void)
Static Public Member Functions inherited from SoInteractionKit
static SoType | getClassTypeId (void)
static const SoNodekitCatalog * | getClassNodekitCatalog (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | setSwitchValue (SoNode *node, const int newVal)
Static Public Member Functions inherited from SoBaseKit
static SoType | getClassTypeId (void)
static void | initClass (void)
static const SoNodekitCatalog * | getClassNodekitCatalog (void)
static SbBool | isSearchingChildren (void)
static void | setSearchingChildren (const SbBool newval)
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes
SoSFRotation | rotation
Public Attributes inherited from SoDragger
SoSFBool | isActive
Public Attributes inherited from SoInteractionKit
SoSFEnum | renderCaching
SoSFEnum | boundingBoxCaching
SoSFEnum | renderCulling
SoSFEnum | pickCulling

## Protected Member Functions
virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoRotateCylindricalDragger (void)
virtual SbBool | setUpConnections (SbBool onoff, SbBool doitalways=FALSE)
virtual void | copyContents (const SoFieldContainer *fromfc, SbBool copyconnections)
void | dragStart (void)
void | drag (void)
void | dragFinish (void)
Protected Member Functions inherited from SoDragger
| SoDragger (void)
virtual | ~SoDragger (void)
SbVec2f | getNormalizedLocaterPosition (void)
SbVec2s | getLocaterPosition (void)
SbVec2s | getStartLocaterPosition (void) const
void | setStartLocaterPosition (SbVec2s p)
SbBool | isAdequateConstraintMotion (void)
virtual SbBool | shouldGrabBasedOnSurrogate (const SoPath *pickpath, const SoPath *surrogatepath)
void | setCameraInfo (SoAction *action)
virtual void | handleEvent (SoHandleEventAction *ha)
void | transferMotion (SoDragger *child)
void | setIgnoreInBbox (SbBool newval)
SbBool | isIgnoreInBbox (void)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
void | setActiveChildDragger (SoDragger *newchilddragger)
SoDragger * | getActiveChildDragger (void) const
virtual void | setDefaultOnNonWritingFields (void)
void | updateDraggerCache (const SoPath *path)
virtual const SoPickedPoint * | getPickedPointForStart (SoHandleEventAction *action)
Protected Member Functions inherited from SoInteractionKit
virtual | ~SoInteractionKit ()
virtual SbBool | setPart (const int partNum, SoNode *node)
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
virtual SbBool | setAnyPartAsDefault (const SbName &partname, SoNode *node, SbBool anypart=TRUE, SbBool onlyifdefault=TRUE)
virtual SbBool | setAnyPartAsDefault (const SbName &partname, const SbName &nodename, SbBool anypart=TRUE, SbBool onlyifdefault=TRUE)
SbBool | setAnySurrogatePath (const SbName &name, SoPath *path, SbBool leafcheck=FALSE, SbBool publiccheck=FALSE)
void | connectSeparatorFields (SoSeparator *dest, SbBool onOff)
Protected Member Functions inherited from SoBaseKit
virtual | ~SoBaseKit ()
virtual SoNode * | addToCopyDict (void) const
SoGroup * | getContainerNode (const SbName &listname, SbBool makeifneeded=TRUE)
virtual SoNode * | getAnyPart (const SbName &partname, SbBool makeifneeded, SbBool leafcheck=FALSE, SbBool publiccheck=FALSE)
virtual SoNodeKitPath * | createPathToAnyPart (const SbName &partname, SbBool makeifneeded, SbBool leafcheck=FALSE, SbBool publiccheck=FALSE, const SoPath *pathtoextend=NULL)
virtual SbBool | setAnyPart (const SbName &partname, SoNode *from, SbBool anypart=TRUE)
void | createNodekitPartsList (void)
void | createFieldList (void)
virtual void | createDefaultParts (void)
const SoNodekitParts * | getNodekitPartsList (void) const
const SbList< SoSFNode * > & | getCatalogInstances (void) const
void | catalogError (void)
void | countMyFields (SoOutput *out)
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const
virtual SoNotRec | createNotRec (void)

## Static Protected Member Functions
static const SoFieldData ** | getFieldDataPtr (void)
static const SoNodekitCatalog ** | getClassNodekitCatalogPtr (void)
static void | startCB (void *f, SoDragger *d)
static void | motionCB (void *f, SoDragger *d)
static void | doneCB (void *f, SoDragger *d)
static void | fieldSensorCB (void *f, SoSensor *s)
static void | valueChangedCB (void *f, SoDragger *d)
Static Protected Member Functions inherited from SoDragger
static const SoFieldData ** | getFieldDataPtr (void)
static const SoNodekitCatalog ** | getClassNodekitCatalogPtr (void)
static void | childTransferMotionAndValueChangedCB (void *, SoDragger *)
static void | childValueChangedCB (void *, SoDragger *)
static void | childStartCB (void *, SoDragger *)
static void | childMotionCB (void *, SoDragger *)
static void | childFinishCB (void *, SoDragger *)
static void | childOtherEventCB (void *, SoDragger *)
Static Protected Member Functions inherited from SoInteractionKit
static const SoFieldData ** | getFieldDataPtr (void)
static const SoNodekitCatalog ** | getClassNodekitCatalogPtr (void)
static void | readDefaultParts (const char *fileName, const char defaultBuffer[], int defBufSize)
static void | fieldSensorCB (void *, SoSensor *)
Static Protected Member Functions inherited from SoBaseKit
static const SoFieldData ** | getFieldDataPtr (void)
static const SoNodekitCatalog ** | getClassNodekitCatalogPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Protected Attributes
SoSFNode | feedback
SoSFNode | feedbackActive
SoSFNode | feedbackSwitch
SoSFNode | rotator
SoSFNode | rotatorActive
SoSFNode | rotatorSwitch
SoFieldSensor * | fieldSensor
SbCylinderProjector * | cylinderProj
SbBool | userProj
Protected Attributes inherited from SoDragger
SoSFNode | motionMatrix
Protected Attributes inherited from SoInteractionKit
SoSFNode | geomSeparator
SoSFNode | topSeparator
SoFieldSensor * | fieldSensor
SoSeparator * | oldTopSep
Protected Attributes inherited from SoBaseKit
SoSFNode | callbackList
SoChildList * | children
SbBool | connectionsSetUp
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn

## Additional Inherited Members
Public Types inherited from SoDragger
enum | ProjectorFrontSetting { FRONT , BACK , USE_PICK }
Public Types inherited from SoInteractionKit
enum | CacheEnabled { OFF , ON , AUTO }
Public Types inherited from SoNode
enum | NodeType { INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 , INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 , COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 , COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 , COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000 }
Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoRotateCylindricalDragger class is for rotating geometry around a single axis.

Here's how the dragger looks with its default geometry in the inactive state:

Screen Shot of Default Dragger

Use an instance of this dragger class in your scene graph to let the end-users of your application rotate geometry around a predefined axis vector in 3D.

For the dragger orientation and positioning itself, use some kind of transformation node in your scene graph, as usual.

## Constructor & Destructor Documentation

## ◆ SoRotateCylindricalDragger()

SoRotateCylindricalDragger::SoRotateCylindricalDragger | ( | void |  | ) |

Default constructor, sets up the dragger nodekit catalog with the interaction and feedback geometry.

Nodekit structure (new entries versus parent class marked with arrow prefix):

    CLASS SoRotateCylindricalDragger
    -->"this"
          "callbackList"
          "topSeparator"
             "motionMatrix"
             "geomSeparator"
    -->         "rotatorSwitch"
    -->            "rotator"
    -->            "rotatorActive"
    -->         "feedbackSwitch"
    -->            "feedback"
    -->            "feedbackActive"

(See SoBaseKit::printDiagram() for information about the output formatting.)

Detailed information on catalog parts:

    CLASS SoRotateCylindricalDragger
    PVT   "this",  SoRotateCylindricalDragger  ---
          "callbackList",  SoNodeKitListPart [ SoCallback, SoEventCallback ]
    PVT   "topSeparator",  SoSeparator  ---
    PVT   "motionMatrix",  SoMatrixTransform  ---
    PVT   "geomSeparator",  SoSeparator  ---
    PVT   "rotatorSwitch",  SoSwitch  ---
          "rotator",  SoSeparator  ---
          "rotatorActive",  SoSeparator  ---
    PVT   "feedbackSwitch",  SoSwitch  ---
          "feedback",  SoSeparator  ---
          "feedbackActive",  SoSeparator  ---

(See SoBaseKit::printTable() for information about the output formatting.)

## ◆ ~SoRotateCylindricalDragger()

SoRotateCylindricalDragger::~SoRotateCylindricalDragger | ( | void |  | ) |
| protectedvirtual

Protected destructor.

(Dragger classes are derived from SoBase, so they are reference counted and automatically destroyed when their reference count goes to 0.)

## Member Function Documentation

## ◆ getClassTypeId()

SoType SoRotateCylindricalDragger::getClassTypeId | ( | void |  | ) |
| static

This static method returns the SoType object associated with objects of this class.

## ◆ getTypeId()

SoType SoRotateCylindricalDragger::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Reimplemented from SoDragger.

## ◆ getFieldDataPtr()

const SoFieldData ** SoRotateCylindricalDragger::getFieldDataPtr | ( | void |  | ) |
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## ◆ getFieldData()

const SoFieldData * SoRotateCylindricalDragger::getFieldData | ( | void |  | ) | const
| protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoDragger.

## ◆ getClassNodekitCatalog()

const SoNodekitCatalog * SoRotateCylindricalDragger::getClassNodekitCatalog | ( | void |  | ) |
| static

Returns the nodekit catalog which defines the layout of this class' kit.

## ◆ getNodekitCatalog()

const SoNodekitCatalog * SoRotateCylindricalDragger::getNodekitCatalog | ( | void |  | ) | const
| virtual

Returns the nodekit catalog which defines the layout of this class' kit.

Reimplemented from SoDragger.

## ◆ getClassNodekitCatalogPtr()

const SoNodekitCatalog ** SoRotateCylindricalDragger::getClassNodekitCatalogPtr | ( | void |  | ) |
| staticprotected

Returns the pointer to the pointer of the nodekit catalog for this class.

## ◆ initClass()

void SoRotateCylindricalDragger::initClass | ( | void |  | ) |
| static

Initializes type system for this dragger class.

Application programmers should usually not have to invoke this method, see documentation of SoInteraction::init().

## ◆ setProjector()

void SoRotateCylindricalDragger::setProjector | ( | SbCylinderProjector * | p | ) |

Replace the default cylinder projection strategy. You may want to do this if you change the dragger geometry, for instance.

The default cylinder projection is an SbCylinderPlaneProjector.

See also
  SbCylinderSectionProjector, SbCylinderSheetProjector

## ◆ getProjector()

const SbCylinderProjector * SoRotateCylindricalDragger::getProjector | ( | void |  | ) | const

Returns projector instance used for converting from user interaction dragger movements to 3D dragger re-orientation.

See also
  setProjector()

## ◆ setUpConnections()

SbBool SoRotateCylindricalDragger::setUpConnections | ( | SbBool | onoff,
|  | SbBool | doitalways = FALSE )
| protectedvirtual

Sets up all internal connections for instances of this class.

(This method will usually not be of interest to the application programmer, unless you want to extend the library with new custom nodekits or dragger classes. If so, see the SoBaseKit class documentation.)

Reimplemented from SoInteractionKit.

## ◆ copyContents()

void SoRotateCylindricalDragger::copyContents | ( | const SoFieldContainer * | from,
|  | SbBool | copyconnections )
| protectedvirtual

Makes a deep copy of all data of from into this instance, except external scene graph references if copyconnections is `FALSE`.

This is the method that should be overridden by extension node / engine / dragger / whatever subclasses which need to account for internal data that are not handled automatically.

For copying nodes from application code, you should not invoke this function directly, but rather call the SoNode::copy() function:

SoNode * mynewnode = templatenode->copy();
SoNode
The SoNode class is the base class for nodes used in scene graphs.
Definition SoNode.h:56
SoNode::copy
virtual SoNode * copy(SbBool copyconnections=FALSE) const
Definition SoNode.cpp:474

The same also goes for engines.

Make sure that when you override the copyContents() method in your extension class that you also make it call upwards to its parent superclass in the inheritance hierarchy, as copyContents() in for instance SoNode and SoFieldContainer does important work. It should go something like this:

void
MyCoinExtensionNode::copyContents(const SoFieldContainer * from,
SbBool copyconnections)
{
// let parent superclasses do their thing (copy fields, copy
// instance name, etc.)
SoNode::copyContents(from, copyconnections);
// [..then copy internal data..]
}
SoFieldContainer
The SoFieldContainer class is a base class for all classes that contain fields.
Definition SoFieldContainer.h:43
SoNode::copyContents
virtual void copyContents(const SoFieldContainer *from, SbBool copyconnections)
Definition SoNode.cpp:1483

Reimplemented from SoInteractionKit.

## ◆ startCB()

void SoRotateCylindricalDragger::startCB | ( | void * | f,
|  | SoDragger * | d )
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ motionCB()

void SoRotateCylindricalDragger::motionCB | ( | void * | f,
|  | SoDragger * | d )
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ doneCB()

void SoRotateCylindricalDragger::doneCB | ( | void * | f,
|  | SoDragger * | d )
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ fieldSensorCB()

void SoRotateCylindricalDragger::fieldSensorCB | ( | void * | d,
|  | SoSensor * | s )
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ valueChangedCB()

void SoRotateCylindricalDragger::valueChangedCB | ( | void * | f,
|  | SoDragger * | d )
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ dragStart()

void SoRotateCylindricalDragger::dragStart | ( | void |  | ) |
| protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Called when dragger is selected (picked) by the user.

## ◆ drag()

void SoRotateCylindricalDragger::drag | ( | void |  | ) |
| protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Called when user drags the mouse after picking the dragger.

## ◆ dragFinish()

void SoRotateCylindricalDragger::dragFinish | ( | void |  | ) |
| protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Called when mouse button is released after picking and interacting with the dragger.

## Member Data Documentation

## ◆ rotation

SoSFRotation SoRotateCylindricalDragger::rotation

This field is continuously updated to contain the rotation of the current direction vector of the dragger.

The application programmer using this dragger in his scene graph should connect the relevant node fields in the scene to this field to make them follow the dragger orientation.

## ◆ fieldSensor

SoFieldSensor* SoRotateCylindricalDragger::fieldSensor
| protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ cylinderProj

SbCylinderProjector* SoRotateCylindricalDragger::cylinderProj
| protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ userProj

SbBool SoRotateCylindricalDragger::userProj
| protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

The documentation for this class was generated from the following files:

- SoRotateCylindricalDragger.h
- SoRotateCylindricalDragger.cpp